
// FireCRFlashSDKDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FireCRFlashSDKDemo.h"
#include "FireCRFlashSDKDemoDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CFireCRFlashSDKDemoDlg dialog
#ifndef USE_EXPLICIT_LINK
#pragma comment(lib, "CRSwingFlash.lib")
#endif


#define MainForm ((CFireCRFlashSDKDemoDlg*)theApp.GetMainWnd())

#define _DebugLog(a)	{ MainForm->GetDlgItem(IDC_EDIT_DEBUG)->SetWindowText((LPCSTR)a);MainForm->GetDlgItem(IDC_EDIT_DEBUG)->UpdateWindow();}

EScannerStatus  gScannerStatus = estNone;
TCallBackSet	callbackSet;

const CString ConnectionList[]		= {"None",	"Ethernet",	"USB"};
const CString scannerStatusList[]	= {"None",	"Disconnected",	"Waiting",	"WarmUp",	"Erasing",	"ScannerReady",	"ReadyForScan",	"Transferring"};
const CString scannerNotifyList[]	= {"None",	"ScanStarted",	"Progressing",	"Preprocessed",	"changeFormat"};
const CString scannerModelList[]	= {"Flash30",	"Flash50",	"Flash70"};
const CString IPList[]				= {"None",	"35x43",	"25x30",	"24x30",	"18x24",	"reserved1",	"reserved2"};
const CString ResolutionList[]		= {"100um",	"200um"};
void cdecl OnScannerStatus(int status)

{
	if(status >(int)estTransferring || status < (int)estNone)
		return;
	gScannerStatus = (EScannerStatus)status;
	MainForm->updateScannerStatus(status);
	TScannerInfo info;
#ifdef USE_EXPLICIT_LINK
		MainForm->m_pfnGetScannerInfo(&info);
#else
		flGetScannerInfo(&info);
#endif
		MainForm->GetDlgItem(IDC_SCANNER_MODEL)->SetWindowText( (LPCSTR)scannerModelList[info.model]);

}
#include <stdio.h>
void cdecl OnScannerNotify(int notify)
{
	MainForm->UpdateData(TRUE);		
	int w, h;
	WORD* src;
	CProgressCtrl*	prgScan		= (CProgressCtrl*)MainForm->GetDlgItem(IDC_PROGRESS_SCANNER);
	CButton*		radRes100   = (CButton*)MainForm->GetDlgItem(IDC_RADIO_100);
	CButton*		radRes200   = (CButton*)MainForm->GetDlgItem(IDC_RADIO_200);
	switch(notify)
	{
	case esnProgress:
#ifdef USE_EXPLICIT_LINK
		if(MainForm->m_pfnGetProgress)
			prgScan->SetPos(MainForm->m_pfnGetProgress());
#else
		prgScan->SetPos(flGetProgress());

#endif
		break;
	case esnPreprocessed:
		//  caution !  if IsCalibrated() returns false, this is not notified!
		{
			OutputDebugString("recv Preprocessed image\n");
#ifdef USE_EXPLICIT_LINK
			MainForm->m_pfnGetImageSize(&w, &h);
			src = MainForm->m_pfnGetImageBuffer();
#else
			flGetImageSize(&w, &h);
			src = flGetImageBuffer();
#endif
			FILE * fp = NULL;
			if(fopen_s(&fp,"image.raw", "wb") == 0)
			{
				fwrite(src, w * h * sizeof(PIXEL_FORMAT), 1, fp);
				fclose(fp);
				CString msg;
				msg.Format(" test.raw W:%4d, H:%4d 16bit gray IBM PC Byte order", w, h);
				//MessageBox(0, (LPSTR)(LPCSTR)msg, "test.raw save", MB_TOPMOST);
				_DebugLog(msg);
			}else _DebugLog("failed to save image.raw")
		}
		break;
	case esnChangeFormat:
#ifdef USE_EXPLICIT_LINK
		MainForm->GetDlgItem(IDC_STATIC_IP)->SetWindowText((LPCSTR)IPList[MainForm->m_pfnGetIPSize() + 1]);//m_pfnGetIPSize return -1 ~ 3
		if(!MainForm->m_pfnGetResolution())
			radRes100->SetCheck(true);
		else
			radRes200->SetCheck(true);
#else
		MainForm->GetDlgItem(IDC_STATIC_IP)->SetWindowText((LPCSTR)IPList[flGetIPSize()]);//GetIPSize return -1 ~ 3
		if(!flGetResolution())
			radRes100->SetCheck(true);
		else
			radRes200->SetCheck(true);
#endif
		break;
	case esnScanStarted:
		_DebugLog("start scanning");
		break;
	case esnScannerError:
		{
			
#ifdef USE_EXPLICIT_LINK
			int Error =  MainForm->m_pfnGetScannerError();

#else
			int Error =  flGetScannerError();
#endif
			if(Error & eseDuplicateSDK)
			{
				AfxMessageBox("duplicate SDK");
				PostQuitMessage(0);
				break;
			}
			else
			{
				CString strError = "Scanner Error\n";
				if(Error & eseScanningTimeOut)	{					strError += "Scaning time out\n";}
				if(Error & eseErasingTimeOut) 	{					strError += " Erasing time out\n";}
				if(Error & eseNoMovingPlate)  	{	strError += "Moving Plate Error\n";}
				if(Error & eseRPMError)			{ 					strError += "RPM Error\n";}
				if(Error & esePSDError)			{					strError += "PSD Error\n";}
				if(Error & eseAlignTimeout)		{					strError += "Align Time out\n";}
				if(Error & eseLaserTempError)	{	strError += "Laser Temperature Error\n";}
				if(Error & eseEraseTempError)	{	strError += "Erase Temperature Error\n";}
				if(strError != "Scanner Error\n")
					OutputDebugStringA((LPSTR)(LPCSTR)strError);
				else
					OutputDebugStringA("Unknown Scanner error\n");
			}
		}
		break;
	}
	MainForm->UpdateData(FALSE);
}

CFireCRFlashSDKDemoDlg::CFireCRFlashSDKDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CFireCRFlashSDKDemoDlg::IDD, pParent)
	, m_bCheckTrace(FALSE)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFireCRFlashSDKDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Check(pDX, IDC_CHECK_TRACE_LOG, m_bCheckTrace);
}

BEGIN_MESSAGE_MAP(CFireCRFlashSDKDemoDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_LOAD, &CFireCRFlashSDKDemoDlg::OnBnClickedBtnLoad)
	ON_BN_CLICKED(IDC_BTN_DISCONNECT, &CFireCRFlashSDKDemoDlg::OnBnClickedBtnDisconnect)
	ON_BN_CLICKED(IDC_BTN_FREE, &CFireCRFlashSDKDemoDlg::OnBnClickedBtnFree)
	ON_BN_CLICKED(IDC_BTN_CONNECT, &CFireCRFlashSDKDemoDlg::OnBnClickedBtnConnect)
	ON_BN_CLICKED(IDC_BTN_GETIMAGE, &CFireCRFlashSDKDemoDlg::OnBnClickedBtnGetimage)
	ON_BN_CLICKED(IDC_BTN_CLOSE, &CFireCRFlashSDKDemoDlg::OnBnClickedBtnClose)
	ON_BN_CLICKED(IDC_BTN_CALIBRATION, &CFireCRFlashSDKDemoDlg::OnBnClickedBtnCalibration)
	ON_BN_CLICKED(IDC_BTN_SCANNERCONTROL, &CFireCRFlashSDKDemoDlg::OnBnClickedBtnScannercontrol)
	ON_MESSAGE(WM_ONSCANNERNOTIFY,	OnScannerNotifyMsg)
	ON_MESSAGE(WM_ONSCANNERSTATUS,	OnScannerStatusMsg)
	ON_BN_CLICKED(IDC_BTN_STOP, &CFireCRFlashSDKDemoDlg::OnBnClickedBtnStop)
	ON_BN_CLICKED(IDC_BTN_SCAN, &CFireCRFlashSDKDemoDlg::OnBnClickedBtnScan)
	ON_BN_CLICKED(IDC_RADIO_100, &CFireCRFlashSDKDemoDlg::OnBnClickedRadio100)
	ON_BN_CLICKED(IDC_RADIO_200, &CFireCRFlashSDKDemoDlg::OnBnClickedRadio200)
END_MESSAGE_MAP()
LRESULT CFireCRFlashSDKDemoDlg::OnScannerNotifyMsg(WPARAM wparam, LPARAM lparam)
{
	::OnScannerNotify((int)wparam);
	return 0;
}
LRESULT CFireCRFlashSDKDemoDlg::OnScannerStatusMsg(WPARAM wparam, LPARAM lparam)
{
	::OnScannerStatus((int)wparam);
	return 0;
}

// CFireCRFlashSDKDemoDlg message handlers

BOOL CFireCRFlashSDKDemoDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
#ifdef USE_EXPLICIT_LINK
	MainForm->SetWindowTextA("Explicit Link Version");
	m_hMod = NULL;
#else
	MainForm->SetWindowTextA("Implicit Link Version");
	((CWnd*)GetDlgItem(IDC_BTN_LOAD))->EnableWindow(FALSE );
	((CWnd*)GetDlgItem(IDC_BTN_FREE))->EnableWindow(FALSE );
#endif
	MainForm->UpdateData(FALSE);
	// TODO: Add extra initialization here

#ifdef USE_EXPLICIT_LINK
	if(LoadDll() == FALSE)
	{
		if(m_bCheckTrace)OutputDebugString("LoadDLL FALSE\n");
		return FALSE;
	}
	#ifndef _USEWINDOWMESSAGE_
		callbackSet.scannerNotifyEvent =  (TOnScannerNotifyEvent)::OnScannerNotify;
		callbackSet.scannerStatusEvent =  (TOnScannerStatusEvent)::OnScannerStatus;
		m_pfnOpenScannerSDK(NULL, &callbackSet,L".");
	#else
		callbackSet.scannerNotifyEvent	= NULL;
		callbackSet.scannerStatusEvent	= NULL;
		m_pfnOpenScannerSDK(m_hWnd, &callbackSet,  L".");
	#endif
	((CWnd*)GetDlgItem(IDC_BTN_LOAD))->EnableWindow(FALSE);
	((CWnd*)GetDlgItem(IDC_BTN_FREE))->EnableWindow(TRUE);
	UpdateData(FALSE);
#else	
	#ifndef _USEWINDOWMESSAGE_
		callbackSet.scannerNotifyEvent =  (TOnScannerNotifyEvent)::OnScannerNotify;
		callbackSet.scannerStatusEvent =  (TOnScannerStatusEvent)::OnScannerStatus;
		flOpenScannerSDK(NULL, &callbackSet,L".");
	#else
		callbackSet.scannerNotifyEvent	= NULL;
		callbackSet.scannerStatusEvent	= NULL;
		flOpenScannerSDK(m_hWnd, &callbackSet,  L".");
	#endif	
#endif
	((CProgressCtrl*)GetDlgItem(IDC_PROGRESS_SCANNER))->SetRange(0,1000);// 0% to 1000%
//	((CButton*)MainForm->GetDlgItem(IDC_RADIO_100))->SetCheck(true);
	UpdateData(FALSE);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFireCRFlashSDKDemoDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFireCRFlashSDKDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CFireCRFlashSDKDemoDlg::OnBnClickedBtnLoad()
{
#ifdef USE_EXPLICIT_LINK
	if(LoadDll() == FALSE)
	{
		if(m_bCheckTrace)OutputDebugString("LoadDLL FALSE\n");
		return;
	}
	#ifndef _USEWINDOWMESSAGE_
		callbackSet.scannerNotifyEvent =  (TOnScannerNotifyEvent)::OnScannerNotify;
		callbackSet.scannerStatusEvent =  (TOnScannerStatusEvent)::OnScannerStatus;
		m_pfnOpenScannerSDK(NULL, &callbackSet,L".");
	#else
		callbackSet.scannerNotifyEvent	= NULL;
		callbackSet.scannerStatusEvent	= NULL;
		m_pfnOpenScannerSDK(m_hWnd, &callbackSet,  L".");
	#endif
	((CWnd*)GetDlgItem(IDC_BTN_LOAD))->EnableWindow(FALSE);
	((CWnd*)GetDlgItem(IDC_BTN_FREE))->EnableWindow(TRUE);
	UpdateData(FALSE);
#else	
	#ifndef _USEWINDOWMESSAGE_
		callbackSet.scannerNotifyEvent =  (TOnScannerNotifyEvent)::OnScannerNotify;
		callbackSet.scannerStatusEvent =  (TOnScannerStatusEvent)::OnScannerStatus;
		flOpenScannerSDK(NULL, &callbackSet,L".");
	#else
		callbackSet.scannerNotifyEvent	= NULL;
		callbackSet.scannerStatusEvent	= NULL;
		flOpenScannerSDK(m_hWnd, &callbackSet,  L".");
	#endif	
#endif
}
void CFireCRFlashSDKDemoDlg::OnBnClickedBtnDisconnect()
{
	UpdateData(TRUE);
#ifdef USE_EXPLICIT_LINK
	if(m_pfnCloseScanner)
		m_pfnCloseScanner();
#else
	flCloseScanner();
#endif
	((CWnd*)GetDlgItem(IDC_BTN_CONNECT))->EnableWindow(TRUE );
	((CWnd*)GetDlgItem(IDC_BTN_DISCONNECT))->EnableWindow(FALSE );
	UpdateData(FALSE);
}


void CFireCRFlashSDKDemoDlg::OnBnClickedBtnFree()
{

#ifdef USE_EXPLICIT_LINK
	FreeDll();// m_pfnCloseScannerSDK in it
#else
	flCloseScannerSDK();
#endif
}


void CFireCRFlashSDKDemoDlg::OnBnClickedBtnConnect()
{
	BOOL bResult = FALSE;
	UpdateData(TRUE);
#ifdef USE_EXPLICIT_LINK
	if(m_pfnOpenScanner)
		bResult = m_pfnOpenScanner();
#else
	bResult = flOpenScanner();
#endif		

	UpdateData(FALSE);
}


void CFireCRFlashSDKDemoDlg::OnBnClickedBtnGetimage()
{
#ifdef USE_EXPLICIT_LINK
	if(  m_pfnGetScannerStatus() < estWarmUp || m_pfnGetScannerStatus() > estReadyForScan)
	{
		AfxMessageBox("not connected or transferring");
		return;
	}
	m_pfnGetImageFromList(0);
#else
	if(  flGetScannerStatus() < estWarmUp || flGetScannerStatus() > estReadyForScan)
	{
		AfxMessageBox("not connected or transferring");
		return;
	}
	flGetImageFromList(0);
#endif
}


void CFireCRFlashSDKDemoDlg::OnBnClickedBtnClose()
{
//	
	OnClose();
}


void CFireCRFlashSDKDemoDlg::OnBnClickedBtnCalibration()
{
#ifdef USE_EXPLICIT_LINK
	if(!m_pfnShowModalCalibrationDialog)
		return;
	if(m_pfnShowModalCalibrationDialog(true) ==FALSE)
		::MessageBox(0,"Calibration is not done","Check Calibration",MB_TOPMOST|MB_ICONWARNING);
#else
	if(flShowModalCalibrationDialog(true) ==FALSE)
		::MessageBox(0,"Calibration is not done","Check Calibration",MB_TOPMOST|MB_ICONWARNING);
#endif
}

void CFireCRFlashSDKDemoDlg::OnBnClickedBtnScannercontrol()
{
#ifdef USE_EXPLICIT_LINK
	if(!m_pfnShowScannerControlDialog)return;
	m_pfnShowScannerControlDialog(true);
#else
	flShowScannerControlDialog(true);
#endif	
}
void CFireCRFlashSDKDemoDlg::OnClose()
{
	// TODO:
	if(m_bCheckTrace)OutputDebugString("CFireCRFlashSDKDemoDlg::OnClose OnBnClickedBtnDisconnect\n");
	OnBnClickedBtnDisconnect();
	if(m_bCheckTrace)OutputDebugString("CFireCRFlashSDKDemoDlg::OnClose OnBnClickedBtnFree\n");
	OnBnClickedBtnFree();
	CDialog::OnClose(); // OnClose != OnDestory
	if(m_bCheckTrace)OutputDebugString("CFireCRFlashSDKDemoDlg::OnClose DestroyWindow\n");
	if(m_bCheckTrace)OutputDebugString("CFireCRFlashSDKDemoDlg::OnClose done\n");
	EndDialog(IDOK);
}
void CFireCRFlashSDKDemoDlg::updateScannerStatus(int status)
{
	CButton*		btnScan		= (CButton*)GetDlgItem(IDC_BTN_SCAN);
	CButton*		btnImage	= (CButton*)GetDlgItem(IDC_BTN_GETIMAGE);
	CButton*		radRes100   = (CButton*)MainForm->GetDlgItem(IDC_RADIO_100);
	CButton*		radRes200   = (CButton*)MainForm->GetDlgItem(IDC_RADIO_200);
	radRes100->EnableWindow(FALSE);
	radRes200->EnableWindow(FALSE);
	btnScan->EnableWindow(FALSE);
	btnImage->EnableWindow(FALSE);
	static int oldStatus = estNone;
	GetDlgItem(IDC_STATUS_SCANNER)->SetWindowText(scannerStatusList[status]);
	GetDlgItem(IDC_STATUS_SCANNER)->UpdateWindow();
	switch(status)
	{
	case estNone:
		break;
	case estDisconnected:
		break;
	case estWaiting:
#ifdef USE_EXPLICIT_LINK
		GetDlgItem(IDC_STATUS_CONNECTION)->SetWindowText( ConnectionList[m_pfnGetScannerConnectionType()]);
#else	
		GetDlgItem(IDC_STATUS_CONNECTION)->SetWindowText( ConnectionList[flGetScannerConnectionType()]);
#endif
		break;
	case estReadyForScan:
#ifdef USE_EXPLICIT_LINK
		if(m_pfnIsCalibrated())
#else
		if(flIsCalibrated())
#endif
		{
			btnScan->EnableWindow(TRUE);
			btnImage->EnableWindow(TRUE);
		}
		radRes100->EnableWindow(TRUE);
		radRes200->EnableWindow(TRUE);
		break;
	case estScannerReady:
	if(oldStatus == estWarmUp)
		{
			TScannerInfo info;
			char pn[128];
#ifdef USE_EXPLICIT_LINK
			GetDlgItem(IDC_STATUS_CONNECTION)->SetWindowText( ConnectionList[m_pfnGetScannerConnectionType()]);
			m_pfnGetScannerInfo(&info);
#else
			flGetScannerInfo(&info);
			GetDlgItem(IDC_STATUS_CONNECTION)->SetWindowText( ConnectionList[flGetScannerConnectionType()]);
#endif
			sprintf_s(pn,"PN:%s",info.PN);
			_DebugLog(pn);
			GetDlgItem(IDC_STATUS_CONNECTION)->UpdateWindow();
		}
#ifdef USE_EXPLICIT_LINK
		if(m_pfnIsCalibrated())
#else
		if(flIsCalibrated())
#endif
		{
			btnImage->EnableWindow(TRUE);
		}
		radRes100->EnableWindow(TRUE);
		radRes200->EnableWindow(TRUE);
		break;
	case estTransferring:
		break;
	}
	oldStatus =	status;
}

#ifdef USE_EXPLICIT_LINK
#include <strsafe.h>
void ErrorMessageBox(LPTSTR lpszFunction) 
{ 
	// Retrieve the system error message for the last-error code

	LPVOID lpMsgBuf;
	LPVOID lpDisplayBuf;
	DWORD dw = GetLastError(); 

	FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM |
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		dw,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPTSTR) &lpMsgBuf,
		0, NULL );

	// Display the error message and exit the process

	lpDisplayBuf = (LPVOID)LocalAlloc(LMEM_ZEROINIT, 
		(lstrlen((LPCTSTR)lpMsgBuf)+lstrlen((LPCTSTR)lpszFunction)+40)*sizeof(TCHAR)); 
	StringCchPrintf((LPTSTR)lpDisplayBuf, 
		LocalSize(lpDisplayBuf) / sizeof(TCHAR),
		TEXT("%s failed with error %d: %s"), 
		lpszFunction, dw, lpMsgBuf); 
	MessageBox(NULL, (LPCTSTR)lpDisplayBuf, TEXT("Error"), MB_OK); 

	LocalFree(lpMsgBuf);
	LocalFree(lpDisplayBuf);
}
BOOL	CFireCRFlashSDKDemoDlg::LoadDll()
{
	if(m_hMod)
	{
		if(m_bCheckTrace)OutputDebugStringA("m_hMod is not NULL return LoadDLL\n");
		return TRUE;
	}
	m_hMod = LoadLibraryA("CRSwingFlash.dll");
	if (m_hMod == NULL)
	{   // Error loading module -- fail as securely as possible
		::MessageBoxA(0,"Cannot load CRSwingFlash.dll\nplease check dll","DLL Error",MB_TOPMOST|MB_ICONERROR);
		return FALSE;
	}
	int nResult = 0;
	int kkk = 0;
	m_pfnOpenScannerSDK = 				( FLOPENSCANNERSDK )		       	GetProcAddress(m_hMod, "_flOpenScannerSDK");			if(!m_pfnOpenScannerSDK)			nResult--;
	m_pfnCloseScannerSDK = 				( FLCLOSESCANNERSDK )		       	GetProcAddress(m_hMod, "_flCloseScannerSDK");			if(!m_pfnCloseScannerSDK)			nResult--;
	m_pfnOpenScanner =					( FLOPENSCANNER )			       	GetProcAddress(m_hMod, "_flOpenScanner");				if(!m_pfnOpenScanner)				nResult--;
	m_pfnCloseScanner = 				( FLCLOSESCANNER )			       	GetProcAddress(m_hMod, "_flCloseScanner");				if(!m_pfnCloseScanner)				nResult--;
	m_pfnGetImageFromList =				( FLGETIMAGEFROMLIST )		       	GetProcAddress(m_hMod, "_flGetImageFromList");			if(!m_pfnGetImageFromList)			nResult--;
	m_pfnGetScannerInfo = 				( FLGETSCANNERINFO )				GetProcAddress(m_hMod, "_flGetScannerInfo");			if(!m_pfnGetScannerInfo)			nResult--;
	m_pfnGetImageSize = 				( FLGETIMAGESIZE )			       	GetProcAddress(m_hMod, "_flGetImageSize");				if(!m_pfnGetImageSize)				nResult--;
	m_pfnGetImageBuffer = 				( FLGETIMAGEBUFFER )		       	GetProcAddress(m_hMod, "_flGetImageBuffer");			if(!m_pfnGetImageBuffer)			nResult--;
	m_pfnShowModalCalibrationDialog = 	( FLSHOWMODALCALIBRATIONDIALOG )	GetProcAddress(m_hMod, "_flShowModalCalibrationDialog");if(!m_pfnShowModalCalibrationDialog)nResult--;
	m_pfnShowScannerControlDialog = 	( FLSHOWSCANNERCONTROLDIALOG )     	GetProcAddress(m_hMod, "_flShowScannerControlDialog");	if(!m_pfnShowScannerControlDialog)	nResult--;
	m_pfnGetProgress = 					( FLGETPROGRESS )			       	GetProcAddress(m_hMod, "_flGetProgress");				if(!m_pfnGetProgress)				nResult--;
	m_pfnGetScannerStatus = 			( FLGETSCANNERSTATUS )		       	GetProcAddress(m_hMod, "_flGetScannerStatus");			if(!m_pfnGetScannerStatus)			nResult--;
	m_pfnGetResolution = 				( FLGETRESOLUTION )			       	GetProcAddress(m_hMod, "_flGetResolution");				if(!m_pfnGetResolution)				nResult--;
	m_pfnGetIPSize = 					( FLGETIPSIZE )				       	GetProcAddress(m_hMod, "_flGetIPSize");					if(!m_pfnGetIPSize)					nResult--;
	m_pfnGetScannerConnectionType = 	( FLGETSCANNERCONNECTIONTYPE )     	GetProcAddress(m_hMod, "_flGetScannerConnectionType");	if(!m_pfnGetScannerConnectionType)	nResult--;
	m_pfnGetScannerError =				( FLGETSCANNERERROR)		       	GetProcAddress(m_hMod, "_flGetScannerError");			if(!m_pfnGetScannerError)			nResult--;
	m_pfnDoRun					 =		( FLDORUN)							GetProcAddress(m_hMod, "_flDoRun");						if(!m_pfnDoRun)						nResult--;
	m_pfnSetResolution = 				( FLSETRESOLUTION )					GetProcAddress(m_hMod, "_flSetResolution");				if(!m_pfnSetResolution)				nResult--;
	m_pfnDoStop					 =		( FLDOSTOP)					   		GetProcAddress(m_hMod, "_flDoStop");					if(!m_pfnDoStop)					nResult--;
	m_pfnIsCalibrated			=		( FLISCALIBRATED )					GetProcAddress(m_hMod, "_flIsCalibrated");				if(!m_pfnIsCalibrated)				nResult--;
	if (nResult <0)
	{
		OutputDebugStringA("nResult is under 0");
		::MessageBoxA(0,"GerProcAddress failed", "ERROR", MB_TOPMOST|MB_ICONERROR);
		return FALSE;
	}
	return TRUE;
}
void CFireCRFlashSDKDemoDlg::FreeDll()
{
	UpdateData(TRUE);
	if(!m_hMod)
		return;
	if(m_hMod)
	{
		if(m_pfnCloseScannerSDK)
			m_pfnCloseScannerSDK();
		FreeLibrary(m_hMod);
	}
	if(m_bCheckTrace)OutputDebugString("CFireCRFlashSDKDemoDlg::FreeDll Done\n");
	m_hMod = NULL;

	m_pfnOpenScannerSDK				= NULL;
	m_pfnCloseScannerSDK			= NULL;
	m_pfnOpenScanner				= NULL;
	m_pfnCloseScanner				= NULL;
	m_pfnGetImageFromList			= NULL;
	m_pfnGetScannerInfo				= NULL;
	m_pfnGetImageSize				= NULL;
	m_pfnGetImageBuffer				= NULL;
	m_pfnShowModalCalibrationDialog = NULL;
	m_pfnShowScannerControlDialog	= NULL;
	m_pfnGetProgress				= NULL;
	m_pfnGetScannerStatus			= NULL;
	m_pfnGetResolution				= NULL;
	m_pfnGetIPSize					= NULL;
	m_pfnSetResolution				= NULL;
	m_pfnDoRun						= NULL;
	m_pfnDoStop						= NULL;
	m_pfnIsCalibrated				= NULL;
	((CWnd*)GetDlgItem(IDC_BTN_LOAD))->EnableWindow(TRUE );
	((CWnd*)GetDlgItem(IDC_BTN_FREE))->EnableWindow(FALSE);
	UpdateData(FALSE);

}
#endif

void CFireCRFlashSDKDemoDlg::OnBnClickedBtnScan()
{
#ifdef USE_EXPLICIT_LINK
	if(m_pfnDoRun)
		if(	!m_pfnDoRun())
			::MessageBoxA(0,"can't run","run error",MB_TOPMOST|MB_ICONERROR);
#else
	if(	!flDoRun())
		::MessageBoxA(0,"can't run","run error",MB_TOPMOST|MB_ICONERROR);
#endif
}

void CFireCRFlashSDKDemoDlg::OnBnClickedBtnStop()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
#ifdef USE_EXPLICIT_LINK
	if(m_pfnDoStop)
		m_pfnDoStop();
#else
	flDoStop();
#endif
}

void CFireCRFlashSDKDemoDlg::OnBnClickedRadio100()
{
#ifdef USE_EXPLICIT_LINK
	if(m_pfnGetResolution() != esr100)
		m_pfnSetResolution(esr100);
#else
	if(flGetResolution() != esr100)
		flSetResolution(esr100);
#endif
}


void CFireCRFlashSDKDemoDlg::OnBnClickedRadio200()
{
#ifdef USE_EXPLICIT_LINK
	if(m_pfnGetResolution() != esr200)
		m_pfnSetResolution(esr200);
#else
	if(flGetResolution() != esr200)
		flSetResolution(esr200);
#endif
}
