﻿// this source can be working with windows message
#define USEWINDOWSMSG

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;//for DLLImport
using System.IO;
//need  .net framework 3.5
namespace FireCRFlashSDKDemoCSharp
{
//------------------------------implement  SDK.h------------------------------------------------
    public enum EIPSize{
	eisNone = -1,				// no ip
	eis35x43 = 0,				// 35x43
	eis25x30,  					//reserved
	eis24x30,					// 24x30
	eis18x24,					// 18x24
	eisReserved,				// reserved
	eisTotal,					// reserved
    };

    public enum EScanResolution {
	esr100 = 0,				// 100um
	esr200,					// 200um
    } ;

    public enum EConnectionType{
	    ectNone = 0,				//not conected
	    ectEthernet,			// ethernet
	    ectUSB,					// USB
    };

    public enum EScannerStatus{
	    estNone = 0,				//none
	    estDisconnected,		// not connect
	    estWaiting,				// try to connection and wait until connection
	    estWarmUp, 				// connected but not ready
	    estErasing,				// erasing after scanning
	    estScannerReady,		// scanner is ready except ip
	    estReadyForScan,		// can run scanning
	    estTransferring,		// scanning or transferring data
    };

    public enum EScannerError{
	    eseOk = 0,						//no error
	    eseScanningTimeOut	= 1,	//scanning timeout
	    eseErasingTimeOut	= 2,	//erasing  timeout
	    eseNoMovingPlate	= 4,	// no movingplate
	    eseRPMError			= 8,	// rpm error						reserved
	    esePSDError			= 16,	// psd error						reserved
	    eseAlignTimeout		= 32,	// align timeout					reserved
	    eseLaserTempError	= 64,	// laser temperature is too hot		reserved
	    eseEraseTempError	= 128,	// eraser temperature is too hot	reserved
	    eseDuplicateSDK		= 65536,// sdk is already running
    };

    public enum EScannerNotify{
	    esnNone = 0,				// none
	    esnScanStarted,			// scanning is srtared
	    esnProgress,			//  transferring progress is changed
	    esnPreprocessed,		//  image is ready
	    esnChangeFormat,		// ip size of resolution is changed
	    esnScannerError,		// error is occurred
    };

    public enum EScannerModel{
	    esmFlash30 = 0,			//FireCR Flash30
	    esmFlash50 = 1,			//FireCR Flash50
	    esmFlash70 = 2			//FireCR Flash70
    };
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void TOnScannerStatusEvent(int param);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void TOnScannerNotifyEvent(int param);

    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
    public struct TCallBackSet {
        [MarshalAs(UnmanagedType.FunctionPtr, SizeConst = 4)]   public  TOnScannerStatusEvent scannerStatusEvent;
        [MarshalAs(UnmanagedType.FunctionPtr, SizeConst = 4)]   public  TOnScannerNotifyEvent scannerNotifyEvent;
    };
    [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
    public struct TScannerInfo
    {
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 16)]    public string nick;
        [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 64)]    public string PN;
        /* failed to change c++ union to c# structure.. 
        [StructLayout(LayoutKind.Explicit)]
                struct IPAddress
                {
                    [FieldOffset(0)]
                    public int quad;
                    [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 4)]
                    [FieldOffset(0)]
                    public byte Bytes0;
                    [FieldOffset(1)]
                    public byte Bytes1;
                    [FieldOffset(2)]
                    public byte Bytes2;
                    [FieldOffset(3)]
                    public byte Bytes3;
                };
         */
        [MarshalAs(UnmanagedType.I4, SizeConst = 4)]
        public int ipaddress;	//
        [MarshalAs(UnmanagedType.I4, SizeConst = 4)]
        public EConnectionType ConnectionType;	//usb etehrnet
        [MarshalAs(UnmanagedType.I4, SizeConst = 4)]
	    public EScannerModel	model;			// 30,50,70
    };
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
//    public delegate int FLOPENSCANNERSDK(int hwnd, ref TCallBackSet callbackSet, [MarshalAs(UnmanagedType.LPWStr)] string configPath);
    public delegate int FLOPENSCANNERSDK(int hwnd, ref TCallBackSet callbackSet, [MarshalAs(UnmanagedType.LPWStr)] string configPath);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void FLCLOSESCANNERSDK();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate int FLOPENSCANNER();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void FLCLOSESCANNER();

    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate int FLGETIMAGEFROMLIST(int index);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void FLGETSCANNERINFO(ref TScannerInfo info);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    unsafe public delegate void FLGETIMAGESIZE(int* width, int* height);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    unsafe public delegate ushort* FLGETIMAGEBUFFER();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate int FLSHOWMODALCALIBRATIONDIALOG(int visible);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate int FLSHOWSCANNERCONTROLDIALOG(int visible);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate int FLGETPROGRESS();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate EScannerStatus FLGETSCANNERSTATUS();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate EScanResolution FLGETRESOLUTION();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate EIPSize FLGETIPSIZE();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate EConnectionType FLGETSCANNERCONNECTIONTYPE();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate int FLGETSCANNERERROR();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate int FLDORUN();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void FLSETRESOLUTION(EScanResolution res);
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate void FLDOSTOP();
    [UnmanagedFunctionPointer(CallingConvention.Cdecl)]
    public delegate int FLISCALIBRATED();
//------------------------------implement  SDK.h------------------------------------------------
    public partial class Form1 : Form
    {

        string []ConnectionList		= {"None",	"Ethernet",	"USB"};
        string []scannerStatusList	= {"None",	"Disconnected",	"Waiting",	"WarmUp",	"Erasing",	"ScannerReady",	"ReadyForScan",	"Transferring"};
        string []scannerNotifyList	= {"None",	"ScanStarted",	"Progressing",	"Preprocessed",	"changeFormat"};
        string []scannerModelList	= {"Flash30",	"Flash50",	"Flash70"};
        string []IPList				= {"None",	"35x43",	"25x30",	"24x30",	"18x24",	"reserved1",	"reserved2"};
        string []ResolutionList		= {"100um",	"200um"};
        
        int   [,]widths             = { {3500,0,2400,2400},     {1750,0,1200,1200}      };
        int[,] height               = { { 4300, 0, 300, 1800 }, { 2150, 0, 1500, 900 }  };
        [DllImport("kernel32.dll", CharSet = CharSet.Ansi, EntryPoint = "LoadLibrary")]
        //public extern static int LoadLibraryA(string libraryName);
        static extern int LoadLibrary([MarshalAs(UnmanagedType.LPStr)] string lpLibFileName);

        [DllImport("kernel32.dll", CharSet = CharSet.Ansi, EntryPoint = "GetProcAddress")]
        static extern IntPtr GetProcAddress(int hModule, [MarshalAs(UnmanagedType.LPStr)] string lpProcName);

        [DllImport("kernel32.dll", CharSet = CharSet.Ansi, EntryPoint = "FreeLibrary")]
        static extern bool FreeLibrary(int hModule);
        public TCallBackSet callbackSet;
        int m_hMod  = 0;
        bool bFirst = false;
        public IntPtr                       m_pfnOpenScannerSDK = IntPtr.Zero;
        public IntPtr                       m_pfnCloseScannerSDK = IntPtr.Zero;
        public IntPtr                       m_pfnOpenScanner = IntPtr.Zero;
        public IntPtr                       m_pfnCloseScanner = IntPtr.Zero;
        public IntPtr                       m_pfnGetImageFromList = IntPtr.Zero;
        public IntPtr                       m_pfnGetScannerInfo = IntPtr.Zero;
        public IntPtr                       m_pfnGetImageSize = IntPtr.Zero;
        public IntPtr                       m_pfnGetImageBuffer = IntPtr.Zero;
        public IntPtr                       m_pfnShowModalCalibrationDialog = IntPtr.Zero;
        public IntPtr                       m_pfnShowScannerControlDialog = IntPtr.Zero;
        public IntPtr                       m_pfnGetProgress = IntPtr.Zero;
        public IntPtr                       m_pfnGetScannerStatus = IntPtr.Zero;
        public IntPtr                       m_pfnGetResolution = IntPtr.Zero;
        public IntPtr                       m_pfnGetIPSize = IntPtr.Zero;
        public IntPtr                       m_pfnGetScannerConnectionType = IntPtr.Zero;
        public IntPtr                       m_pfnGetScannerError = IntPtr.Zero;
        public IntPtr                       m_pfnDoRun = IntPtr.Zero;
        public IntPtr                       m_pfnSetResolution = IntPtr.Zero;
        public IntPtr                       m_pfnDoStop = IntPtr.Zero;
        public IntPtr                       m_pfnIsCalibrated = IntPtr.Zero;

	    public FLOPENSCANNERSDK				_pfnOpenScannerSDK;
	    public FLCLOSESCANNERSDK			_pfnCloseScannerSDK;
	    public FLOPENSCANNER				_pfnOpenScanner;
	    public FLCLOSESCANNER				_pfnCloseScanner;
	    public FLGETIMAGEFROMLIST			_pfnGetImageFromList;
	    public FLGETSCANNERINFO				_pfnGetScannerInfo;
	    public FLGETIMAGESIZE				_pfnGetImageSize;
	    public FLGETIMAGEBUFFER				_pfnGetImageBuffer;
	    public FLSHOWMODALCALIBRATIONDIALOG	_pfnShowModalCalibrationDialog;
	    public FLSHOWSCANNERCONTROLDIALOG	_pfnShowScannerControlDialog;
	    public FLGETPROGRESS				_pfnGetProgress;
	    public FLGETSCANNERSTATUS			_pfnGetScannerStatus;
	    public FLGETRESOLUTION				_pfnGetResolution;
	    public FLGETIPSIZE					_pfnGetIPSize;
	    public FLGETSCANNERCONNECTIONTYPE	_pfnGetScannerConnectionType;
	    public FLGETSCANNERERROR			_pfnGetScannerError;
	    public FLDORUN						_pfnDoRun;
	    public FLSETRESOLUTION				_pfnSetResolution;
	    public FLDOSTOP						_pfnDoStop;
	    public FLISCALIBRATED				_pfnIsCalibrated;
        const int   width35x43              = 3500;
        const int   height35x43             = 4300;

        public static void StatusEventFunc(int param)
        {
            // for callback
            publicWrapper.pMain.updateStatus(param);

        }
        public static void NotifyEventFunc(int param)
        {
            // for callback
            publicWrapper.pMain.updateNotofy(param);
            
        }
        TOnScannerStatusEvent statHandler; //avoid to CallbackOnCollectedDelegate
        TOnScannerNotifyEvent notiHandler;//avoid to CallbackOnCollectedDelegate

        public Form1()
        {
            InitializeComponent();
            publicWrapper.pMain = this;
            callbackSet = new TCallBackSet();
            statHandler = new TOnScannerStatusEvent(StatusEventFunc);
            notiHandler = new TOnScannerNotifyEvent(NotifyEventFunc);
#if USEWINDOWSMSG
            callbackSet.scannerNotifyEvent = null;
            callbackSet.scannerStatusEvent = null;
#else           
            callbackSet.scannerNotifyEvent = notiHandler;
            callbackSet.scannerStatusEvent = statHandler;
#endif

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
        }
        private void Form1_FormClosed(object sender, EventArgs e)
        {
                
            m_btnDisconnect_Click(null, null);
            m_btnFree_Click(null, null);
        }
        private void m_btnConnect_Click(object sender, EventArgs e)
        {
            if (_pfnOpenScanner == null)
                return;
            int bResult = _pfnOpenScanner();
            if (bResult < 1)
                MessageBox.Show("can't connect");
            else
                m_btnDisconnect.Enabled = true;
        }

        private void m_btnLoad_Click(object sender, EventArgs e)
        {
            if (m_hMod != 0)
                return;
            string curpath = System.IO.Directory.GetCurrentDirectory();
            string dllpath = curpath + "\\CRSwingFlash.dll";
            m_hMod = LoadLibrary( dllpath);
            if (m_hMod == 0)
            {
                System.Windows.Forms.MessageBox.Show("Can not load CRSwingFlash.dll\ncheck dll", "Error");
                return;
            }
            int nResult = 0;
            m_pfnOpenScannerSDK             = GetProcAddress(m_hMod, "_flOpenScannerSDK");              if (IntPtr.Zero == m_pfnOpenScannerSDK) nResult--;
            m_pfnCloseScannerSDK            = GetProcAddress(m_hMod, "_flCloseScannerSDK");             if (IntPtr.Zero == m_pfnCloseScannerSDK) nResult--;
            m_pfnOpenScanner                = GetProcAddress(m_hMod, "_flOpenScanner");                 if (IntPtr.Zero == m_pfnOpenScanner) nResult--;
            m_pfnCloseScanner               = GetProcAddress(m_hMod, "_flCloseScanner");                if (IntPtr.Zero == m_pfnCloseScanner) nResult--;
            m_pfnGetImageFromList           = GetProcAddress(m_hMod, "_flGetImageFromList");            if (IntPtr.Zero == m_pfnGetImageFromList) nResult--;
            m_pfnGetScannerInfo             = GetProcAddress(m_hMod, "_flGetScannerInfo");              if (IntPtr.Zero == m_pfnGetScannerInfo) nResult--;
            m_pfnGetImageSize               = GetProcAddress(m_hMod, "_flGetImageSize");                if (IntPtr.Zero == m_pfnGetImageSize) nResult--;
            m_pfnGetImageBuffer             = GetProcAddress(m_hMod, "_flGetImageBuffer");              if (IntPtr.Zero == m_pfnGetImageBuffer) nResult--;
            m_pfnShowModalCalibrationDialog = GetProcAddress(m_hMod, "_flShowModalCalibrationDialog");  if (IntPtr.Zero == m_pfnShowModalCalibrationDialog) nResult--;
            m_pfnShowScannerControlDialog   = GetProcAddress(m_hMod, "_flShowScannerControlDialog");    if (IntPtr.Zero == m_pfnShowScannerControlDialog) nResult--;
            m_pfnGetProgress                = GetProcAddress(m_hMod, "_flGetProgress");                 if (IntPtr.Zero == m_pfnGetProgress) nResult--;
            m_pfnGetScannerStatus           = GetProcAddress(m_hMod, "_flGetScannerStatus");            if (IntPtr.Zero == m_pfnGetScannerStatus) nResult--;
            m_pfnGetResolution              = GetProcAddress(m_hMod, "_flGetResolution");               if (IntPtr.Zero == m_pfnGetResolution) nResult--;
            m_pfnGetIPSize                  = GetProcAddress(m_hMod, "_flGetIPSize");                   if (IntPtr.Zero == m_pfnGetIPSize) nResult--;
            m_pfnGetScannerConnectionType   = GetProcAddress(m_hMod, "_flGetScannerConnectionType");    if (IntPtr.Zero == m_pfnGetScannerConnectionType) nResult--;
            m_pfnGetScannerError            = GetProcAddress(m_hMod, "_flGetScannerError");             if (IntPtr.Zero == m_pfnGetScannerError) nResult--;
            m_pfnDoRun                      = GetProcAddress(m_hMod, "_flDoRun");                       if (IntPtr.Zero == m_pfnDoRun) nResult--;
            m_pfnSetResolution              = GetProcAddress(m_hMod, "_flSetResolution");               if (IntPtr.Zero == m_pfnSetResolution) nResult--;
            m_pfnDoStop                     = GetProcAddress(m_hMod, "_flDoStop");                      if (IntPtr.Zero == m_pfnDoStop) nResult--;
            m_pfnIsCalibrated               = GetProcAddress(m_hMod, "_flIsCalibrated");                if (IntPtr.Zero == m_pfnIsCalibrated) nResult--;
            if (nResult < 0)
            {
                System.Windows.Forms.MessageBox.Show(Convert.ToString(nResult), "Failed");
                return;
            }
            _pfnOpenScannerSDK              = (FLOPENSCANNERSDK)                Marshal.GetDelegateForFunctionPointer(m_pfnOpenScannerSDK, typeof(FLOPENSCANNERSDK));
            _pfnCloseScannerSDK             = (FLCLOSESCANNERSDK)               Marshal.GetDelegateForFunctionPointer(m_pfnCloseScannerSDK, typeof(FLCLOSESCANNERSDK));
            _pfnOpenScanner                 = (FLOPENSCANNER)                   Marshal.GetDelegateForFunctionPointer(m_pfnOpenScanner, typeof(FLOPENSCANNER));
            _pfnCloseScanner                = (FLCLOSESCANNER)                  Marshal.GetDelegateForFunctionPointer(m_pfnCloseScanner, typeof(FLCLOSESCANNER));
            _pfnGetImageFromList            = (FLGETIMAGEFROMLIST)              Marshal.GetDelegateForFunctionPointer(m_pfnGetImageFromList, typeof(FLGETIMAGEFROMLIST));
            _pfnGetScannerInfo              = (FLGETSCANNERINFO)                Marshal.GetDelegateForFunctionPointer(m_pfnGetScannerInfo, typeof(FLGETSCANNERINFO));
            _pfnGetImageSize                = (FLGETIMAGESIZE)                  Marshal.GetDelegateForFunctionPointer(m_pfnGetImageSize, typeof(FLGETIMAGESIZE));
            _pfnGetImageBuffer              = (FLGETIMAGEBUFFER)                Marshal.GetDelegateForFunctionPointer(m_pfnGetImageBuffer, typeof(FLGETIMAGEBUFFER));
            _pfnShowModalCalibrationDialog  = (FLSHOWMODALCALIBRATIONDIALOG)    Marshal.GetDelegateForFunctionPointer(m_pfnShowModalCalibrationDialog, typeof(FLSHOWMODALCALIBRATIONDIALOG));
            _pfnShowScannerControlDialog    = (FLSHOWSCANNERCONTROLDIALOG)      Marshal.GetDelegateForFunctionPointer(m_pfnShowScannerControlDialog, typeof(FLSHOWSCANNERCONTROLDIALOG));
            _pfnGetProgress                 = (FLGETPROGRESS)                   Marshal.GetDelegateForFunctionPointer(m_pfnGetProgress, typeof(FLGETPROGRESS));
            _pfnGetScannerStatus            = (FLGETSCANNERSTATUS)              Marshal.GetDelegateForFunctionPointer(m_pfnGetScannerStatus, typeof(FLGETSCANNERSTATUS));
            _pfnGetResolution               = (FLGETRESOLUTION)                 Marshal.GetDelegateForFunctionPointer(m_pfnGetResolution, typeof(FLGETRESOLUTION));
            _pfnGetIPSize                   = (FLGETIPSIZE)                     Marshal.GetDelegateForFunctionPointer(m_pfnGetIPSize, typeof(FLGETIPSIZE));
            _pfnGetScannerConnectionType    = (FLGETSCANNERCONNECTIONTYPE)      Marshal.GetDelegateForFunctionPointer(m_pfnGetScannerConnectionType, typeof(FLGETSCANNERCONNECTIONTYPE));
            _pfnGetScannerError             = (FLGETSCANNERERROR)               Marshal.GetDelegateForFunctionPointer(m_pfnGetScannerError, typeof(FLGETSCANNERERROR));
            _pfnDoRun                       = (FLDORUN)                         Marshal.GetDelegateForFunctionPointer(m_pfnDoRun, typeof(FLDORUN));
            _pfnSetResolution               = (FLSETRESOLUTION)                 Marshal.GetDelegateForFunctionPointer(m_pfnSetResolution, typeof(FLSETRESOLUTION));
            _pfnDoStop                      = (FLDOSTOP)                        Marshal.GetDelegateForFunctionPointer(m_pfnDoStop, typeof(FLDOSTOP));
            _pfnIsCalibrated                = (FLISCALIBRATED)                  Marshal.GetDelegateForFunctionPointer(m_pfnIsCalibrated, typeof(FLISCALIBRATED));

            unsafe
            {
                
#if USEWINDOWSMSG
                _pfnOpenScannerSDK(this.Handle.ToInt32(), ref callbackSet, curpath);
#else
                //this mode doesnot  working 
                _pfnOpenScannerSDK(0, ref callbackSet, curpath);
#endif


            }
            m_prgProgress.Maximum   = 1000;
            m_prgProgress.Minimum   = 0;
            m_prgProgress.Value     = 0;
            m_btnFree.Enabled       = true;
            m_btnConnect.Enabled    = true;
            m_btnLoad.Enabled       = true;
            m_btnLastImage.Enabled  = true;
            m_radRes100.Enabled     = true;
            m_radRes200.Enabled     = true;
            m_btnScannerControl.Enabled = true;
            m_btnCalibrationControl.Enabled = true;
            updateStatus((int)EScannerStatus.estDisconnected);
            publicWrapper._debugLog("loaded dll");
        }

        private void m_btnDisconnect_Click(object sender, EventArgs e)
        {
            if (_pfnCloseScanner == null)
                return;
            _pfnCloseScanner();
        }

        private void m_btnClose_Click(object sender, EventArgs e)
        {
        }

        private void m_btnScan_Click(object sender, EventArgs e)
        {
            if (_pfnDoRun == null)
                return;

            int lresult = _pfnDoRun();
            if (lresult < 1)
                MessageBox.Show("can't run");
        }

        private void m_btnStop_Click(object sender, EventArgs e)
        {
            if (_pfnDoStop == null)
                return;
            _pfnDoStop();
        }

        private void m_btnLastImage_Click(object sender, EventArgs e)
        {

            if(_pfnGetScannerStatus == null || _pfnGetImageFromList == null)
                return;
            EScannerStatus curstatus = _pfnGetScannerStatus();
            if ( curstatus  < EScannerStatus.estWarmUp || curstatus > EScannerStatus.estReadyForScan)
            {
                MessageBox.Show("not connected or transferring");
                return;
            }
            _pfnGetImageFromList(0);
        }

        private void m_btnFree_Click(object sender, EventArgs e)
        {
            if (m_hMod != 0)
            {
                if(_pfnCloseScannerSDK != null)
                    _pfnCloseScannerSDK();
                FreeLibrary(m_hMod);
                m_pfnOpenScannerSDK             = IntPtr.Zero;  _pfnOpenScannerSDK              = null;
                m_pfnCloseScannerSDK            = IntPtr.Zero;  _pfnCloseScannerSDK             = null;
                m_pfnOpenScanner                = IntPtr.Zero;  _pfnOpenScanner                 = null;
                m_pfnCloseScanner               = IntPtr.Zero;  _pfnCloseScanner                = null;
                m_pfnGetImageFromList           = IntPtr.Zero;  _pfnGetImageFromList            = null;
                m_pfnGetScannerInfo             = IntPtr.Zero;  _pfnGetScannerInfo              = null;
                m_pfnGetImageSize               = IntPtr.Zero;  _pfnGetImageSize                = null;
                m_pfnGetImageBuffer             = IntPtr.Zero;  _pfnGetImageBuffer              = null;
                m_pfnShowModalCalibrationDialog = IntPtr.Zero;  _pfnShowModalCalibrationDialog  = null;
                m_pfnShowScannerControlDialog   = IntPtr.Zero;  _pfnShowScannerControlDialog    = null;
                m_pfnGetProgress                = IntPtr.Zero;  _pfnGetProgress                 = null;
                m_pfnGetScannerStatus           = IntPtr.Zero;  _pfnGetScannerStatus            = null;
                m_pfnGetResolution              = IntPtr.Zero;  _pfnGetResolution               = null;
                m_pfnGetIPSize                  = IntPtr.Zero;  _pfnGetIPSize                   = null;
                m_pfnGetScannerConnectionType   = IntPtr.Zero;  _pfnGetScannerConnectionType    = null;
                m_pfnGetScannerError            = IntPtr.Zero;  _pfnGetScannerError             = null;
                m_pfnDoRun                      = IntPtr.Zero;  _pfnDoRun                       = null;
                m_pfnSetResolution              = IntPtr.Zero;  _pfnSetResolution               = null;
                m_pfnIsCalibrated               = IntPtr.Zero;  _pfnIsCalibrated                = null;
            }   
            m_hMod = 0;
            m_prgProgress.Value = 0;
            m_btnFree.Enabled = false;
            m_btnConnect.Enabled = false;
            m_btnLoad.Enabled = false;
            m_btnLastImage.Enabled = false;
            m_radRes100.Enabled = false;
            m_radRes200.Enabled = false;
            m_btnScannerControl.Enabled = false;
            m_btnCalibrationControl.Enabled = false;

        }

        private void radRes100_Click(object sender, EventArgs e)
        {

        }
        private void radRes100_CheckedChanged(object sender, EventArgs e)
        {
            if (_pfnGetScannerStatus == null || _pfnGetResolution == null || _pfnSetResolution == null)
                return;
            EScannerStatus curStatus = _pfnGetScannerStatus();
            if (curStatus < EScannerStatus.estWarmUp || curStatus > EScannerStatus.estReadyForScan)
                return;
            if (_pfnGetResolution() != EScanResolution.esr100)
                _pfnSetResolution(EScanResolution.esr100);
        }
        private void radRes200_Click(object sender, EventArgs e)
        {
        }
        private void radRes200_CheckedChanged(object sender, EventArgs e)
        {
            if (_pfnGetScannerStatus == null || _pfnGetResolution == null || _pfnSetResolution == null)
                return;
            EScannerStatus curStatus = _pfnGetScannerStatus();
            if (curStatus < EScannerStatus.estWarmUp || curStatus > EScannerStatus.estReadyForScan)
                return;
            if (_pfnGetResolution() != EScanResolution.esr200)
                _pfnSetResolution(EScanResolution.esr200);
        }


        public void updateStatus(int status)
        {
            GC.Collect();
            m_lblScannerStatus.Text = scannerStatusList[status];

            if (status > (int)EScannerStatus.estTransferring || status < (int)EScannerStatus.estNone)
                return;
            switch (status)
            {
            case (int)EScannerStatus.estNone:
                m_btnScan.Enabled = false;
                m_btnStop.Enabled = false;
                m_radRes100.Enabled = false;
                m_radRes200.Enabled = false;                    
                m_btnLastImage.Enabled = false;
                break;
            case (int)EScannerStatus.estDisconnected:
                m_prgProgress.Value = 0;
                m_btnScan.Enabled = false;
                m_btnStop.Enabled = false;
                m_radRes100.Enabled = false;
                m_radRes200.Enabled = false;                    
                m_btnLastImage.Enabled = false;
                break;
            case (int)EScannerStatus.estWaiting:
                break;
            case (int)EScannerStatus.estWarmUp:
                m_prgProgress.Value = 0;
                m_btnStop.Enabled = true;
                TScannerInfo scannerinfo = new TScannerInfo();
                _pfnGetScannerInfo(ref scannerinfo);
                string pn = "PN : " + scannerinfo.PN;
                publicWrapper._debugLog(pn);
                break;
            case (int) EScannerStatus.estErasing:
                break;
            case (int) EScannerStatus.estScannerReady:
                m_btnStop.Enabled = true;
                m_btnLastImage.Enabled = true;
                m_radRes100.Enabled = true;
                m_radRes200.Enabled = true;
                break;
            case (int) EScannerStatus.estReadyForScan:
                if (_pfnIsCalibrated() > 0)
                m_btnScan.Enabled = true;
                m_btnStop.Enabled = true;
                m_radRes100.Enabled = true;
                m_radRes200.Enabled = true;
                break;
            case (int) EScannerStatus.estTransferring:
                m_btnScan.Enabled = false;
                m_btnLastImage.Enabled = true;
                m_radRes100.Enabled = false;
                m_radRes200.Enabled = false;
                break;
             }
            TScannerInfo info = new TScannerInfo();
            _pfnGetScannerInfo(ref info);
            int modelindex = 0;
            modelindex = (int)info.model;
            if (modelindex > 5 || modelindex < 0)
                m_lblModel.Text = "none";
            else
                m_lblModel.Text = scannerModelList[modelindex];
            int connectionType = (int)info.ConnectionType;
            if (connectionType > 2 || connectionType < 0)
                connectionType = 0;
            m_lbl_ScannerInfo.Text = ConnectionList[connectionType];
         }

        public void updateNotofy(int notify)
        {
            GC.Collect();
            switch (notify)
            {
            case (int)EScannerNotify.esnNone:
                break;
            case (int)EScannerNotify.esnScanStarted:
                publicWrapper._debugLog("scan started");
                break;
            case (int)EScannerNotify.esnProgress:
                m_prgProgress.Value = _pfnGetProgress();
                break;
            case (int)EScannerNotify.esnPreprocessed:
                publicWrapper._debugLog("scan done");
                int w = 0, h = 0;
                unsafe
                {
                    _pfnGetImageSize(&w, &h);
                }
                ushort[] buffer = new ushort[w * h];
                unsafe
                {
                    ushort* src = _pfnGetImageBuffer();
                    for (int i = 0; i < w * h; i++)
                        buffer[i] = src[i];
                    
                }
                FileStream fs = new FileStream("image.raw", FileMode.Create,FileAccess.Write);
                BinaryWriter bw = new BinaryWriter(fs);
                byte[] tmp = publicWrapper.GetByteArrayFromushortArray(buffer);
                bw.Write(tmp);
                bw.Close();
                bw = null;
                fs = null;
                buffer = null;
                tmp = null;
                string imageinfo =  "image.raw W : " + Convert.ToString(w) + " H : " + Convert.ToString(h) + " 16bit gray IBM PC Byte order raw image";
                publicWrapper._debugLog(imageinfo);
                break;
            case (int)EScannerNotify.esnChangeFormat:
                int isres200 = (int)_pfnGetResolution();
                if (isres200 == 0)
                    _pfnSetResolution(EScanResolution.esr100);
                else
                    _pfnSetResolution(EScanResolution.esr200);
                m_lblIP.Text = IPList[(int)_pfnGetIPSize() + 1];
                break;
            case (int)EScannerNotify.esnScannerError:
                int Error = _pfnGetScannerError();
                string strError = "Scanner Error\n";
				if ((Error & (int)EScannerError.eseScanningTimeOut) > 0)	{					strError += "Scaning time out\n";}
                if ((Error & (int)EScannerError.eseErasingTimeOut) > 0) { strError += " Erasing time out\n"; }
                if ((Error & (int)EScannerError.eseNoMovingPlate) > 0) { strError += "Moving Plate Error\n"; }
                if ((Error & (int)EScannerError.eseRPMError) > 0) { strError += "RPM Error\n"; }
                if ((Error & (int)EScannerError.esePSDError) > 0) { strError += "PSD Error\n"; }
                if ((Error & (int)EScannerError.eseAlignTimeout) > 0) { strError += "Align Time out\n"; }
                if ((Error & (int)EScannerError.eseLaserTempError) > 0) { strError += "Laser Temperature Error\n"; }
                if ((Error & (int)EScannerError.eseEraseTempError) > 0) { strError += "Erase Temperature Error\n"; }
                if (strError != "Scanner Error\n")
                    MessageBox.Show(strError);
                break;
            }
        }

        private void m_btnCalibrationControl_Click(object sender, EventArgs e)
        {
           	if(_pfnShowModalCalibrationDialog == null)
		        return;
	        if(_pfnShowModalCalibrationDialog(1) < 1)
                System.Windows.Forms.MessageBox.Show("Calibration is not done", "Check Calibration");
        }

        private void m_btnScannerControl_Click(object sender, EventArgs e)
        {
            if (_pfnShowScannerControlDialog == null) return;
                _pfnShowScannerControlDialog(1);
        }

        private void Form1_Activated(object sender, EventArgs e)
        {
            if (bFirst)
                return;
            bFirst = true;
            m_btnLoad_Click(null, null);
        }
        protected override void WndProc(ref Message msg)
        {
            base.WndProc(ref msg);
            switch (msg.Msg)
            {
                case 1024 + 301://WM_ONSCANNERSTATUS
                    publicWrapper.pMain.updateStatus((int)msg.WParam);
                    break;
                case 1024 + 302://WM_ONSCANNERNOTIFY
                    publicWrapper.pMain.updateNotofy((int)msg.WParam);
                    break;
            }
        }

    }
    class publicWrapper
    {   // to use global variable/ function like c++
        public static Form1 pMain = null;
        public static void _debugLog(string a) { pMain.m_edtTrace.Text = a; }
        public static byte[] GetByteArrayFromushortArray(ushort[] intArray)
        {

            byte[] data = new byte[intArray.Length * 2];

            for (int i = 0; i < intArray.Length; i++)

                Array.Copy(BitConverter.GetBytes(intArray[i]), 0, data, i * 2, 2);

            return data;

        }

    }
}
